Mesh to Part: Difference between revisions

From FreeCAD Documentation
(code and spaces)
({{Powerdocnavi{{#translation:}}}} for the proper category)
(7 intermediate revisions by 2 users not shown)
Line 1: Line 1:
<languages/>
<translate>
<translate>
<!--T:11-->
{{docnav|Topological data scripting|Scenegraph}}

== Converting Part objects to Meshes == <!--T:1-->
== Converting Part objects to Meshes == <!--T:1-->


Line 56: Line 60:
</translate>
</translate>
{{Code|code=
{{Code|code=
import Mesh,Part
import Mesh
import Part

mesh = Mesh.createTorus()
mesh = Mesh.createTorus()
shape = Part.Shape()
shape = Part.Shape()
Line 62: Line 68:
solid = Part.makeSolid(shape)
solid = Part.makeSolid(shape)
Part.show(solid)
Part.show(solid)

}}
}}
<translate>
<translate>

<!--T:8-->
<!--T:8-->
The second method offers the possibility to consider mesh facets coplanar when the angle between them is under a certain value. This allows to build much simpler shapes: (let's assume our document contains one Mesh object)
The second method offers the possibility to consider mesh facets coplanar when the angle between them is under a certain value. This allows to build much simpler shapes: (let's assume our document contains one Mesh object)
Line 70: Line 76:
{{Code|code=
{{Code|code=
# let's assume our document contains one Mesh object
# let's assume our document contains one Mesh object
import Mesh,Part,MeshPart
import Mesh
import Part
import MeshPart

faces = []
faces = []
mesh = App.ActiveDocument.ActiveObject.Mesh
mesh = App.ActiveDocument.ActiveObject.Mesh
Line 81: Line 90:
# we assume that the exterior boundary is that one with the biggest bounding box
# we assume that the exterior boundary is that one with the biggest bounding box
if len(wires) > 0:
if len(wires) > 0:
ext=None
ext = None
max_length=0
max_length=0
for i in wires:
for i in wires:
Line 93: Line 102:
i.reverse()
i.reverse()


# make sure that the exterior wires comes as first in the lsit
# make sure that the exterior wires comes as first in the list
wires.insert(0, ext)
wires.insert(0, ext)
faces.append(Part.Face(wires))
faces.append(Part.Face(wires))


shell=Part.Compound(faces)
shell = Part.Compound(faces)
Part.show(shell)
Part.show(shell)
#solid = Part.Solid(Part.Shell(faces))
# solid = Part.Solid(Part.Shell(faces))
#Part.show(solid)
# Part.show(solid)

}}
}}
<translate>
<translate>
<!--T:9-->
<!--T:9-->
{{docnav|Topological data scripting|Scenegraph}}
{{docnav|Topological data scripting|Scenegraph}}

<!--T:10-->
[[Category:Poweruser Documentation]]
[[Category:Python Code]]


</translate>
</translate>
{{Powerdocnavi{{#translation:}}}}
{{clear}}
[[Category:Python Code{{#translation:}}]]
<languages/>

Revision as of 00:37, 12 May 2020

Topological data scripting
Scenegraph

Converting Part objects to Meshes

Converting higher-level objects such as Part shapes into simpler objects such as meshes is a pretty simple operation, where all faces of a Part object get triangulated. The result of that triangulation (tessellation) is then used to construct a mesh: (let's assume our document contains one part object)

#let's assume our document contains one part object
import Mesh
faces = []
shape = FreeCAD.ActiveDocument.ActiveObject.Shape
triangles = shape.tessellate(1) # the number represents the precision of the tessellation)
for tri in triangles[1]:
    face = []
    for i in range(3):
        vindex = tri[i]
        face.append(triangles[0][vindex])
    faces.append(face)
m = Mesh.Mesh(faces)
Mesh.show(m)

Sometimes the triangulation of certain faces offered by OpenCascade is quite ugly. If the face has a rectangular parameter space and doesn't contain any holes or other trimming curves you can also create a mesh on your own:

import Mesh
def makeMeshFromFace(u,v,face):
	(a,b,c,d)=face.ParameterRange
	pts=[]
	for j in range(v):
		for i in range(u):
			s=1.0/(u-1)*(i*b+(u-1-i)*a)
			t=1.0/(v-1)*(j*d+(v-1-j)*c)
			pts.append(face.valueAt(s,t))

	mesh=Mesh.Mesh()
	for j in range(v-1):
		for i in range(u-1):
			mesh.addFacet(pts[u*j+i],pts[u*j+i+1],pts[u*(j+1)+i])
			mesh.addFacet(pts[u*(j+1)+i],pts[u*j+i+1],pts[u*(j+1)+i+1])

	return mesh

Converting Meshes to Part objects

Converting Meshes to Part objects is an extremely important operation in CAD work, because very often you receive 3D data in mesh format from other people or outputted from other applications. Meshes are very practical to represent free-form geometry and big visual scenes, as it is very lightweight, but for CAD we generally prefer higher-level objects that carry much more information, such as the idea of solid, or faces made of curves instead of triangles.

Converting meshes to those higher-level objects (handled by the Part Module in FreeCAD) is not an easy operation. Meshes can be made of thousands of triangles (for example when generated by a 3D scanner), and having solids made of the same number of faces would be extremely heavy to manipulate. So you generally want to optimize the object when converting.

FreeCAD currently offers two methods to convert Meshes to Part objects. The first method is a simple, direct conversion, without any optimization:

import Mesh
import Part

mesh = Mesh.createTorus()
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Topology,0.05) # the second arg is the tolerance for sewing
solid = Part.makeSolid(shape)
Part.show(solid)

The second method offers the possibility to consider mesh facets coplanar when the angle between them is under a certain value. This allows to build much simpler shapes: (let's assume our document contains one Mesh object)

# let's assume our document contains one Mesh object
import Mesh
import Part
import MeshPart

faces = []
mesh = App.ActiveDocument.ActiveObject.Mesh
segments = mesh.getPlanes(0.00001) # use rather strict tolerance here
 
for i in segments:
  if len(i) > 0:
     # a segment can have inner holes
     wires = MeshPart.wireFromSegment(mesh, i)
     # we assume that the exterior boundary is that one with the biggest bounding box
     if len(wires) > 0:
        ext = None
        max_length=0
        for i in wires:
           if i.BoundBox.DiagonalLength > max_length:
              max_length = i.BoundBox.DiagonalLength
              ext = i

        wires.remove(ext)
        # all interior wires mark a hole and must reverse their orientation, otherwise Part.Face fails
        for i in wires:
           i.reverse()

        # make sure that the exterior wires comes as first in the list
        wires.insert(0, ext)
        faces.append(Part.Face(wires))

shell = Part.Compound(faces)
Part.show(shell)
# solid = Part.Solid(Part.Shell(faces))
# Part.show(solid)
Topological data scripting
Scenegraph